//
// rocket.h
//

void InitRocket ( short index )
{
  if ( abs((Rocket[index].dx-Rocket[index].ax)) < abs((Rocket[index].dy-Rocket[index].ay)) )
  {
    if ( Rocket[index].ay > Rocket[index].dy )
    {
      Rocket[index].l.yincr = -1;
      Rocket[index].l.dy = Rocket[index].ay - Rocket[index].dy;                                      
    }
    else
    {
      Rocket[index].l.yincr = 1;
      Rocket[index].l.dy = Rocket[index].dy - Rocket[index].ay;
    }
    Rocket[index].l.div = 1;

    if ( Rocket[index].dx > Rocket[index].ax ) Rocket[index].l.xincr = 1;
    else Rocket[index].l.xincr = -1;
    Rocket[index].l.dx = abs( Rocket[index].dx-Rocket[index].ax );                                      // rel. X-Lnge
    Rocket[index].l.d  = 2 * Rocket[index].l.dx - Rocket[index].l.dy;
    Rocket[index].l.aincr = 2 * (Rocket[index].l.dx - Rocket[index].l.dy);
    Rocket[index].l.bincr = 2 * Rocket[index].l.dx;
    Rocket[index].l.x = Rocket[index].ax;
    Rocket[index].l.y = Rocket[index].ay;
  }
  else
  {
    if ( Rocket[index].ax > Rocket[index].dx )
    {
      Rocket[index].l.xincr = -1;
      Rocket[index].l.dx = Rocket[index].ax - Rocket[index].dx;
    }
    else
    {
      Rocket[index].l.xincr = 1;
      Rocket[index].l.dx = Rocket[index].dx - Rocket[index].ax;
    }

    Rocket[index].l.div = 0;

    if ( Rocket[index].dy > Rocket[index].ay ) Rocket[index].l.yincr = 1;
    else Rocket[index].l.yincr = -1;
    Rocket[index].l.dy = abs( Rocket[index].dy-Rocket[index].ay );
    Rocket[index].l.d  = 2 * Rocket[index].l.dy - Rocket[index].l.dx;           
    Rocket[index].l.aincr = 2 * (Rocket[index].l.dy - Rocket[index].l.dx);      
    Rocket[index].l.bincr = 2 * Rocket[index].l.dy;
    Rocket[index].l.x = Rocket[index].ax;
    Rocket[index].l.y = Rocket[index].ay;
  }
}


void RocketInsert ( short ax, short ay, short owner )
{
  static short i;

  RocketAnz++;
  if ( RocketAnz >= ROCKETMAX ) { RocketAnz--; return; }

  Rocket[RocketNextFree].free         = 1;
  Rocket[RocketNextFree].ax           = ax;
  Rocket[RocketNextFree].ay           = ay;
  Rocket[RocketNextFree].dx           = Leute[owner].zx;
  Rocket[RocketNextFree].dy           = Leute[owner].zy;
  Rocket[RocketNextFree].length       = 7;
  Rocket[RocketNextFree].speed        = 5;                                
  Rocket[RocketNextFree].destruct     = Data[Leute[owner].type].destruct; 
  Rocket[RocketNextFree].farbe        = 254;   
  Rocket[RocketNextFree].owner        = owner;   
  
  InitRocket(RocketNextFree);
  Leute[owner].zaehler = 8;

  for(i=RocketNextFree; i<ROCKETMAX; ++i) if ( !Rocket[i].free ) { RocketNextFree = i; return; }
}


void RocketDelete ( short index )
{
  RocketAnz--;
  Rocket[index].free = 0;

  if ( index < RocketNextFree ) RocketNextFree = index;
  Leute[Rocket[index].owner].attack = 0;
  Leute[Rocket[index].owner].who    = 255;
}

void CalcRocketPoint ( short index )
{
   if ( Rocket[index].l.div  )
   {
     if ( Rocket[index].l.d >= 0 ) { Rocket[index].l.x += Rocket[index].l.xincr; Rocket[index].l.d += Rocket[index].l.aincr; }
     else Rocket[index].l.d += Rocket[index].l.bincr; 
     Rocket[index].l.y += Rocket[index].l.yincr;
   }
   else
   {
     if ( Rocket[index].l.d >= 0 ) { Rocket[index].l.y += Rocket[index].l.yincr; Rocket[index].l.d += Rocket[index].l.aincr; }
     else Rocket[index].l.d += Rocket[index].l.bincr;
     Rocket[index].l.x += Rocket[index].l.xincr;
   }  
}  


void RocketEnde ( short index )
{
  short i;

  for(i=0; i<LMAX; i++)
  {
    if ( ((Rocket[index].l.x>=Leute[i].ax)&&(Rocket[index].l.x<=(Leute[i].ax+Leute[i].shapeX)))&&
         ((Rocket[index].l.y>=Leute[i].ay)&&(Rocket[index].l.y<=(Leute[i].ay+Leute[i].shapeY))) )
    {
      Leute[i].energie -= Rocket[index].destruct;
    }  
  }
  RocketDelete(index);
}


void RocketCompute ( short index )
{
  static short i, x, y;
  static LINE  puffer;

  y = x = 0;
  //------------------------------------------------------//
  if ( GameDel >= GameSpeed )
  {
    for(i=0; i<Rocket[index].speed; i++) CalcRocketPoint(index);
    if ( Rocket[index].ax < Rocket[index].dx ) { if ( Rocket[index].l.x > Rocket[index].dx ) x=1; }
    else { if ( Rocket[index].l.x <= Rocket[index].dx ) x=1; }
    if ( Rocket[index].ay < Rocket[index].dy ) { if ( Rocket[index].l.y > Rocket[index].dy ) y=1; }
    else { if ( Rocket[index].l.y <= Rocket[index].dy ) y=1; }
    if ( (y==1)&&(x==1) ) { RocketEnde(index); return; }
  }
  memcpy(&puffer, &Rocket[index].l, sizeof(LINE));

  for(i=0; i<Rocket[index].length; i++)
  {
    CalcRocketPoint(index);
    ssetpix(Rocket[index].l.x-ScrollX, Rocket[index].l.y-ScrollY, Rocket[index].farbe);
    if ( Rocket[index].ax < Rocket[index].dx ) { if ( Rocket[index].l.x > Rocket[index].dx ) x=1; }
    else { if ( Rocket[index].l.x <= Rocket[index].dx ) x=1; }
    if ( Rocket[index].ay < Rocket[index].dy ) { if ( Rocket[index].l.y > Rocket[index].dy ) y=1; }
    else { if ( Rocket[index].l.y <= Rocket[index].dy ) y=1; }
    if ( (y==1)&&(x==1) ) { RocketEnde(index); return; }
  }

  memcpy(&Rocket[index].l, &puffer, sizeof(LINE));
  if ( GameDel >= GameSpeed ) RauchInsert(Rocket[index].l.x-ScrollX, Rocket[index].l.y-ScrollY);
}


